python Exception(异常处理)-阿里云开发者社区

开发者社区> 开发与运维> 正文
登录阅读全文

python Exception(异常处理)

简介:
python异常:
   python在运行时错误称为异常
       语法错误:软件的结构上有错误而导致不能被解释器解释或不能被编译器编译。
       逻辑错误:由于不完整或不合法的输入所致,也可能是逻辑无法生成、计算或者出结果需要的过程无法执行等。
   默认情况下:python脚本执行过程中出现异常后,脚本执行将被终止。
   
   python 异常是一个对象,表示错误或意外的情况
   在python检测到一个错误时,将触发一个异常:
       python可以通过异常传导机制传递一个异常对象,发出一个异常情况出现的信号。
       程序员也可以在代码中托运触发异常
   python异常也可以理解为:程序出现了错误,而在正常控制流以外采取的行为
       第一阶段:解释器触发异常,此时当前程序流将被打断。
       第二阶段:异常处理,如忽略非致命错误、减轻错误带来的影响等。

异常的功用
   错误处理:
       python的默认处理:停止程序,打印错误消息
       使用try语句处理异常,并从异常中恢复
   事件通知:
       用于发出有效状态信号
   特殊情况处理:
       无法调整代码去处理的场景
   终止行为:
       try/finally语句可确保执行必需的结束处理机制
   非常规控制流程:
       异常是一种高级跳转(goto)机制

异常对象
   python异常是内置的经典类exception的子类的实例
       为了向后兼容,python还允许使用字符串或任何经典类实例
       python2.5之后,exception是从BaseException继承的新式类(即exception的父类是BaseException类)
   python自身引发的所有异常都是Exception的子类的实例
   大多的标准异常都是由StandardError派生的,其有3个抽象的子类
       ArithmeticError:由于算术错误而引发的异常基类;包括:OverflowError、ZeroDivisionError、FloatingPorintError
       LookupError:容器在接收到一个无效的键或索引时引发的异常的基类;包括:IndexError、KeyError
       EnvironmentError:由于外部原因而导致的异常的基类;包括:IOError、OSError、WindowsError
           
标准异常类
   AssertionError:断言语句失败
   AttributeError:属性引用或赋值失败
   FloatingPointError:浮点型运算失败
   IOError:I/O操作失败
   ImportError:import语句不能找到要导入的模块,或者不能找到该模块特别请求的名称。
   IndentationError:解析器遇到了一个由于错误的缩进而引发的语法错误
   IndexError:用来索引序列的整数超出了范围。
   KeyError:用来索引映射的键不在映射中
   KeyboardInterrupt:用户按了中断键(ctrl+c、ctrl+break、delete键)
   MemoryError:运算耗尽内存
   NameError:引用了一个不存在的变量名
   NotImplementedError:由抽象基类引发的异常,用于指示一个具体的子类必须覆盖一个方法
   OSError:由模块os中的函数引发的异常,用来指示平台相关的错误
   OverflowError:整数运算的结果太大导致溢出
   SyntaxError:语法错误
   SystemError:python解释器本身或某些扩展模块中的内部错误 
   TypeError:对某对象执行了不支持的操作
   UnboundLocalError:引用未绑定值的本地变量 
   UnicodeError:在Unicode的字符串之间进行转换时发生的错误 
   ValueError:应用于某个对象的操作或函数,这个对象具有正确的类型,但确有不适当的值
   WindowsError:模块OS中的函数引发的异常,用于指示与windowsSHUDR QAYK 
   ZeroDivisionError:除数为0引发的异常  

检测和处理异常:
   异常通过try语句来检测:任何在try语句块中的代码都会被监测,以检查有无异常发生。
   tr语句主要有两种形式:
       try-except:检测和处理异常
           可以有多个except;支持使用else子句处理没有探测异常的执行的代码
       try-finally:仅检查异常并做一些必要的清理工作
           仅能有一个finally
   try语句的复合形式: try-except-finally    
   注意:try语句中的任何语句出现异常后,就会跳至定义的相关except中,而try结构中发生异常之后的其它语句就不会再执行。
   
   try - except语句:定义了进程异常监控的一段代码,并且提供了处理异常的机制
   语法:
       try:
           try_suite
       except Exception[, reason]:
           except_suite
       或
       try:
           try_suite
       except (Exception1,Exception2[,...])[, reason]:
           except_suite
           
   例:
       try:
           f1 = open('/tmp/a.txt','r')
       except IOError, e:
           print 'Could not open file:', e
       或
       try:
           f1 = open('/tmp/a.txt','r')
       except (IOError,AttrubitError), e:
           print 'Could not open file:', e

   try-except-else语句: try语句可以带多个except子句,还可以有一个可选的else子句
   语法格式如下:
       try:
           try_suite
       except Exception1[, reason]:
           suite_exception1
       except (Exception2, Exception3, ...)[, reason]:     #一次捕获多个异常时要定义为元组
           suite_
       ...
       except:         #空except语句用于捕获一切异常或者使用 except Exception,e:   也可以捕获一切异常
           suite_
       else:            #没有出现错误时执行的代码
           else_suite
           
       except 分句个数没有限制,但else只能有一个;没有异常发生时,else分句才会执行
       没有符合的except分句时,异常会向上传递到程序中的之前进程的try中或者到进程的顶层(解释器)
   
   try-finally语句:无论异常是否发生,finally子句都会执行。常用于定义必需进行的清理动作,如关闭文件或断开服务器连接等。
   finally中的所有代码执行完毕后会继续向上一层引发异常
   语法:
       try:
           try_suite
       finally:
           finally_suite
           
   例:
       try:
           f1 = open('/tmp/a.txt','r')
           f1.write('hello world')
       finally:
           f1.close()            
       关闭文件后继续向上触发异常

   exception 表示异常类型   reason表示接收异常原因的变量
   NameError
   IOError
   TypeError
   SyntaxError
   KeyError
   AttributeError
   IndexError
   ZeroDivisionError  除0错误
  
   #!/usr/bin/python27
   #
   try:
   while True:
   d1 = raw_input("An integer:")
   if d1 == 'quit': break
   d2 = raw_input("Another integer:")
   print int(d1) / int(d2)
   except ZeroDivisionError, e:
   print "not 0"
   except ValueError:
   print "not string"
   except:
   print "Unkown error"

总结:try语句的分句形式
   except:         捕捉所有(其他)异常类型
   except name:    只捕捉特定的异常
   except name, value: 捕捉所有列出的异常和其额外的数据(或实例)
   except (name1, name2):      捕捉任何列出的异常
   except (name1, name2), value:   捕捉任何列出的异常,并取得其额外数据
   else:                   如果没有引发异常,就运行
   finally:        总是会运行此代码块

   语法:    
       try:
           try_suite
       except  Exception1:
           suite1_exception1
       except (exception2, exception3):
           suite23_exception23
       ...
       else:
           else_suite
       finally:
           finally_suite
       可以替换为在try-finally语句中嵌套try-except语句的形式。
   
       try:
           try:
               try_suite
           except ...
           except ...
           else ..
       finally:
           ....
  
自定义异常:
   raise语句可显式触发异常(即手机触发异常)
       raise [SomeException [, args [, traceback]]]
           SomeException:可选,异常的名字,仅能使用字符串、类或实例
           args:可选,以元组的形式传递给异常的参数
           traceback:可选,异常触发时新生成的一个用于异常--正常化的跟踪记录,多用于重新引发异常时使用。                
   例:
       def f1(seq1,seq2):
           if not seq1 or not seq2:
               raise ValueError, "Seq must not be empty."
           print [ (x,y) for x in seq1 fro y in seq2 ]
           
       l1 = [1,2,3]
       l2 = ['a','b','c']
       f1(l1,l2)
       l3 = []
       f1(l1,l3)       提示自定义的异常
       
   try:
       f1 = open('/tmp/a/b.txt','r')
   except BaseException:
       print "Eroor occurs"    
   #注意:BaseException是所有异常对象的父类,所以它可以接收所有的异常。
   
   try:
       a = 3 / 0
   except BaseException:
       print "Error occurs."
       
   自定义异常类:
       自定义异常类和多重继承。较有效的方法是从自定义异常类和标准异常类进行多重继承,例如:
           class CustomAttributeError(CustomException,AttributeError):
               pass
       标准库中使用的其它异常
           python标准库中的许多模块都定义了自己的异常类,如socket中的socket.error; 等同于自定义的异常类
           
   例:
       class MyError(Exception):
           def __init__(self,msg):
               self.Message=msg
           def __str__(self):
               return self.Message
           
       try:
           a=1
           raise MyError('错误测试')
       except Exception,e:
           print e

   assert语句:
   assert语句用于在程序中引入调度代码,语法如下:
       assert  condition[, expression]
       说明:如果condition条件满足,则assert不做任何操作;如果condition条件不满足,则assert使用expression作为参数实例化AssertionError并引发结果实例(即生成一个自定义的断言异常对象)
       注意:如果运行python时使用了-O优化选项,则assert将是一个空操作:编译器不为assert语句生成代码
       运行python时不使用-O选项,则__debug__内置变量为True,否则其值为False
       assert语句相当于下面的代码:
           if __debug__:
               if not condition:
                   raise AssertionError, <expression>
       assert实现:手动触发异常。    
       assert 1 == 0, 'Something wrong'









本文转自 meteor_hy 51CTO博客,原文链接:http://blog.51cto.com/caiyuanji/1834031,如需转载请自行联系原作者

版权声明:本文内容由阿里云实名注册用户自发贡献,版权归原作者所有,阿里云开发者社区不拥有其著作权,亦不承担相应法律责任。具体规则请查看《阿里云开发者社区用户服务协议》和《阿里云开发者社区知识产权保护指引》。如果您发现本社区中有涉嫌抄袭的内容,填写侵权投诉表单进行举报,一经查实,本社区将立刻删除涉嫌侵权内容。

分享:
开发与运维
使用钉钉扫一扫加入圈子
+ 订阅

集结各类场景实战经验,助你开发运维畅行无忧

其他文章